/*
**	DatePanel.c
**
**	Editing panel for date selection
**
**	Copyright  1990-1993 by Olaf `Olsen' Barthel & MXM
**		All Rights Reserved
*/

#include "termGlobal.h"

enum	{	GAD_MONTH,GAD_DAY,GAD_COMMENT,GAD_USE,GAD_CANCEL };

STATIC UBYTE * __saveds
ShowMonth(struct Gadget *SomeGadget,WORD Level)
{
	STATIC UBYTE Month[20];

	SPrintf(Month,"%9s",LocaleString(Level + MSG_DATEPANEL_JANUARY_TXT));

	return(Month);
}

STATIC struct Gadget *
CreateAllGadgets(struct TimeDateNode *Node,struct Gadget **GadgetArray,struct Gadget **GadgetList)
{
	struct Gadget		*Gadget;
	struct NewGadget	 NewGadget;
	UWORD			 Counter = 0;

	SZ_SizeSetup(Window -> WScreen,&UserFont,TRUE);

	memset(&NewGadget,0,sizeof(struct NewGadget));

	if(Gadget = CreateContext(GadgetList))
	{
		SZ_AddLeftOffset(SZ_LeftOffsetN(MSG_DATEPANEL_MONTH_GAD,MSG_DATEPANEL_DAY_GAD,MSG_GLOBAL_COMMENT_GAD,-1));

		SZ_SetWidth(SZ_Width(STRING_KIND,NULL,20,NULL));

		NewGadget . ng_GadgetText	= LocaleString(MSG_DATEPANEL_MONTH_GAD);
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_Flags		= PLACETEXT_LEFT|NG_HIGHLABEL;

		GadgetArray[Counter++] = Gadget = CreateGadget(SLIDER_KIND,Gadget,&NewGadget,
			SZ_Adjust,		TRUE,
			SZ_AutoWidth,		TRUE,

			GTSL_Level,		Node -> Header . Month,
			GTSL_Max,		11,
			GTSL_MaxLevelLen,	9,
			GTSL_LevelFormat,	"%s",
			GTSL_DispFunc,		ShowMonth,
			PGA_Freedom,		LORIENT_HORIZ,
			GA_Immediate,		TRUE,
			GA_RelVerify,		TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_DATEPANEL_DAY_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(SLIDER_KIND,Gadget,&NewGadget,
			SZ_Adjust,		TRUE,
			SZ_AutoWidth,		TRUE,

			GTSL_Level,		Node -> Header . Day,
			GTSL_Min,		1,
			GTSL_Max,		31,
			GTSL_MaxLevelLen,	2,
			GTSL_LevelFormat,	"%2ld",
			PGA_Freedom,		LORIENT_HORIZ,
			GA_Immediate,		TRUE,
			GA_RelVerify,		TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_COMMENT_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTST_MaxChars,	19,
			GTST_String,	Node -> Header . Comment,
			GA_Immediate,	TRUE,
		TAG_DONE);

		SZ_UpdateMaxWidth(BUTTON_KIND,LocaleString(MSG_GLOBAL_USE_GAD),0,NULL);
		SZ_UpdateMaxWidth(BUTTON_KIND,LocaleString(MSG_GLOBAL_CANCEL_GAD),0,NULL);

		SZ_SetWidth(SZ_ResetMaxWidth());

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_USE_GAD);
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_Flags		= 0;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_AlignExtra,	TRUE,
			SZ_AlignLeft,	TRUE,
			SZ_AlignBottom,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_CANCEL_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_AlignRight,	TRUE,
		TAG_DONE);
	}

	return(Gadget);
}

BYTE
DatePanel(struct TimeDateNode *Node)
{
	STATIC BYTE MaxDays[12] = { 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };

	struct Window		*PanelWindow;
	struct Gadget		*GadgetList;
	struct Gadget		*GadgetArray[GAD_CANCEL + 1];
	BYTE			 Result = FALSE;
	struct TimeDateNode	 LocalNode;

	LocalNode = *Node;

	if(CreateAllGadgets(Node,GadgetArray,&GadgetList))
	{
		if(PanelWindow = OpenWindowTags(NULL,
			WA_Left,	GetScreenLeft(Window) + (GetScreenWidth(Window) - SZ_GetWindowWidth()) / 2,
			WA_Top,		GetScreenTop(Window) + (GetScreenHeight(Window) - SZ_GetWindowHeight())	/ 2,
			WA_Width,	SZ_GetWindowWidth(),
			WA_Height,	SZ_GetWindowHeight(),

			WA_Activate,	TRUE,
			WA_DragBar,	TRUE,
			WA_DepthGadget,	TRUE,
			WA_RMBTrap,	TRUE,
			WA_DepthGadget,	TRUE,
			WA_CloseGadget,	TRUE,
			WA_CustomScreen,Window -> WScreen,
			WA_IDCMP,	IDCMP_ACTIVEWINDOW | IDCMP_CLOSEWINDOW | IDCMP_RAWKEY | IDCMP_VANILLAKEY | IDCMP_GADGETDOWN | BUTTONIDCMP | SLIDERIDCMP | STRINGIDCMP,
			WA_Title,	LocaleString(MSG_DATEPANEL_DATE_SETTINGS_TXT),
		TAG_DONE))
		{
			struct IntuiMessage	*Massage;
			ULONG			 IClass,Code;
			struct Gadget		*Gadget;
			BYTE			 Terminated = FALSE;

			GuideContext(CONTEXT_DATE);

			PushWindow(PanelWindow);

			AddGList(PanelWindow,GadgetList,(UWORD)-1,(UWORD)-1,NULL);
			RefreshGList(GadgetList,PanelWindow,NULL,(UWORD)-1);
			GT_RefreshWindow(PanelWindow,NULL);

			ActiveGadget = NULL;

			ClrSignal(SIG_BREAK);

			while(!Terminated)
			{
				if(Wait(PORTMASK(PanelWindow -> UserPort) | SIG_BREAK) & SIG_BREAK)
				{
					*Node = LocalNode;

					break;
				}

				while(!Terminated && (Massage = (struct IntuiMessage *)GT_GetIMsg(PanelWindow -> UserPort)))
				{
					IClass	= Massage -> Class;
					Code	= Massage -> Code;
					Gadget	= (struct Gadget *)Massage -> IAddress;

					GT_ReplyIMsg(Massage);

					KeySelect(GadgetArray,GAD_CANCEL,Code,PanelWindow,&Gadget,&IClass,&Code);

					if(IClass == IDCMP_GADGETDOWN)
					{
						if((Gadget -> GadgetType & GTYP_GTYPEMASK) == GTYP_STRGADGET)
							ActiveGadget = Gadget;
					}

					if(IClass == IDCMP_ACTIVEWINDOW && ActiveGadget)
						ActivateGadget(ActiveGadget,PanelWindow,NULL);

					if(IClass == IDCMP_CLOSEWINDOW)
					{
						*Node = LocalNode;

						Terminated = TRUE;
					}

					if(IClass == IDCMP_MOUSEMOVE)
					{
						switch(Gadget -> GadgetID)
						{
							case GAD_MONTH:

								Node -> Header . Month = Code;
								break;

							case GAD_DAY:

								Node -> Header . Day = Code;
								break;
						}
					}

					if(IClass == IDCMP_GADGETUP)
					{
						switch(Gadget -> GadgetID)
						{
							case GAD_MONTH:

								Node -> Header . Month = Code;

								if(Node -> Header . Day > MaxDays[Node -> Header . Month])
								{
									GT_SetGadgetAttrs(GadgetArray[GAD_DAY],PanelWindow,NULL,
										GTSL_Level,	Node -> Header . Day = MaxDays[Node -> Header . Month],
									TAG_DONE);
								}

								break;

							case GAD_DAY:

								if(Code > MaxDays[Node -> Header . Month])
								{
									Code = MaxDays[Node -> Header . Month];

									GT_SetGadgetAttrs(GadgetArray[GAD_DAY],PanelWindow,NULL,
										GTSL_Level,	Code,
									TAG_DONE);
								}

								Node -> Header . Day = Code;
								break;

							case GAD_USE:

								strcpy(Node -> Header . Comment,SZ_GetString(GadgetArray[GAD_COMMENT]));

								Terminated = TRUE;

								Result = TRUE;

								break;

							case GAD_CANCEL:

								*Node = LocalNode;

								Terminated = TRUE;

								break;
						}
					}
				}
			}

			RemoveGList(PanelWindow,GadgetList,(UWORD)-1);

			PopWindow();

			CloseWindow(PanelWindow);
		}

		FreeGadgets(GadgetList);
	}

	ActiveGadget = NULL;

	return(Result);
}
